package com.arms.api.analysis.time.controller;

import com.arms.api.analysis.time.dto.TimeDTO;
import com.arms.api.analysis.time.service.AnalysisTime;
import com.arms.api.issue.almapi.model.entity.AlmIssueEntity;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/engine/analysis-time")
@Slf4j
@AllArgsConstructor
public class AnalysisTimeController {

    private final AnalysisTime analysisTime;

    // 히트맵
    @PostMapping("/updated-alm-issues")
    public ResponseEntity<List<AlmIssueEntity>> findUpdatedIssues(@RequestBody TimeDTO timeDTO) {

        log.info("요구사항 분석 컨트롤러 :: ALM_이슈_누적_업데이트_목록_조회");

        return ResponseEntity.ok(analysisTime.findUpdatedIssues(timeDTO));
    }

}
