package com.arms.api.dashboard.controller;

import com.arms.api.util.model.dto.request.지라이슈_기본_검색_집계_하위_요청;
import com.arms.api.util.model.dto.request.트리맵_검색_집계_하위_요청;
import com.arms.api.util.model.vo.Worker;
import com.arms.egovframework.javaservice.esframework.model.vo.버킷_집계_결과_목록_합계;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import com.arms.api.dashboard.service.지라이슈_대시보드_서비스;

import java.util.List;

@RestController
@RequestMapping("/engine/jira/dashboard")
@Slf4j
@AllArgsConstructor
public class 지라이슈_대시보드_컨트롤러 {

    private final 지라이슈_대시보드_서비스 지라이슈_대시보드_서비스;



    // Dashboard
    @PostMapping("/assignees-requirements-involvements")
    public ResponseEntity<List<Worker>> 작업자_별_요구사항_별_관여도_apache(
            @RequestBody 트리맵_검색_집계_하위_요청 트리맵_집계_요청
    ) {
        log.info("[지라이슈_대시보드_컨트롤러 :: 작업자_별_요구사항_별_관여도_apache]");

        return ResponseEntity.ok(지라이슈_대시보드_서비스.작업자_별_요구사항_별_관여도(트리맵_집계_요청));
    }

    @PostMapping("/pdService-version-req/{pdServiceId}")
    public ResponseEntity<버킷_집계_결과_목록_합계> 제품_버전_요구사항_이슈_집계(@PathVariable Long pdServiceId,
                                                        @RequestBody 지라이슈_기본_검색_집계_하위_요청 지라이슈_일반_집계_요청) {

        log.info("[지라이슈_대시보드_컨트롤러 :: 제품_버전_요구사항_이슈_집계]");

        return ResponseEntity.ok(지라이슈_대시보드_서비스.제품_버전_요구사항_이슈_집계(pdServiceId, 지라이슈_일반_집계_요청));
    }
}
