package com.arms.api.issue.almapi.model.dto;

import static com.arms.config.ApplicationContextProvider.*;

import com.arms.api.issue.almapi.model.vo.지라이슈_데이터;
import com.arms.api.issue.almapi.model.vo.지라이슈_벌크_추가_요청_유효성;
import com.arms.api.issue.almapi.service.이슈전략_호출;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;

import java.util.List;

@AllArgsConstructor
@Builder
@Getter
@Slf4j
@지라이슈_벌크_추가_요청_유효성
public class 요구사항_데이터 {

    private Long 지라서버_아이디;

    private String 이슈_키;

    private String 프로젝트키_또는_아이디;

    private Long 제품서비스_아이디;

    private List<Long> 제품서비스_버전들;

    private Long cReqLink;

    private 암스_요구사항_속성정보 cReqProperty;

    private String startDate;

    private String endDate;

    public 요구사항_데이터(long 지라서버_아이디, String 이슈_키, String 프로젝트키_또는_아이디, long 제품서비스_아이디, List<Long> 제품서비스_버전들, Long cReqLink, 암스_요구사항_속성정보 cReqProperty) {
        this.지라서버_아이디 = 지라서버_아이디;
        this.이슈_키 = 이슈_키;
        this.프로젝트키_또는_아이디 = 프로젝트키_또는_아이디;
        this.제품서비스_아이디 = 제품서비스_아이디;
        this.제품서비스_버전들 = 제품서비스_버전들;
        this.cReqLink = cReqLink;
        this.cReqProperty = cReqProperty;
    }

    public String 조회조건_아이디(){
        return 지라서버_아이디 + "_" + 프로젝트키_또는_아이디 + "_" + 이슈_키;
    }

    public void 지라이슈_이동으로_키_변경(String 신규_이슈_키){
        this.이슈_키 = 신규_이슈_키;
    }

    public boolean 지라이슈_이동을_했다면(String 신규_이슈_키){
        return !StringUtils.equals(this.이슈_키, 신규_이슈_키);
    }

    public String 연결이슈_조회조건_아이디(지라이슈_데이터 지라이슈_데이터) {
        return 지라서버_아이디 + "_" + 지라이슈_데이터.getFields().getProject().getKey() + "_" + 지라이슈_데이터.getKey();
    }

    public 지라이슈_데이터 지라이슈_데이터_가져오기() throws Exception {
        return getBean(이슈전략_호출.class).이슈_상세정보_가져오기(this);
    }

    public boolean ALM_요구사항_존재_하면() throws Exception {
        return 지라이슈_데이터_가져오기() != null;
    }


}
