package com.arms.egovframework.javaservice.esframework.esquery.must;


import com.arms.egovframework.javaservice.esframework.esquery.Filter;
import com.arms.egovframework.javaservice.esframework.esquery.MustNot;
import org.elasticsearch.index.query.AbstractQueryBuilder;
import org.elasticsearch.index.query.QueryBuilders;
import org.elasticsearch.index.query.TermsQueryBuilder;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

public class TermsQueryMustNot extends MustNot<TermsQueryBuilder> {

	private TermsQueryBuilder termsQueryBuilder;


	public TermsQueryMustNot(String name, Object[] object){
		if(name!=null&&object!=null){
			this.termsQueryBuilder = QueryBuilders.termsQuery(name, object);
		}
	}
	public TermsQueryMustNot(String name, String value){
		if(name!=null&&value!=null){
			this.termsQueryBuilder = QueryBuilders.termsQuery(name, List.of(value));
		}
	}

	public TermsQueryMustNot(String name, List<?> value){
		if(name!=null&&value!=null){
			this.termsQueryBuilder = QueryBuilders.termsQuery(name, value);
		}
	}

	public TermsQueryMustNot(String name, Long value){
		if(name!=null&&value!=null){
			this.termsQueryBuilder = QueryBuilders.termsQuery(name, List.of(value));
		}
	}

	public TermsQueryMustNot(String name, Boolean value){
		if(name!=null&&value!=null){
			this.termsQueryBuilder = QueryBuilders.termsQuery(name, value);
		}
	}

	public TermsQueryMustNot(String name, Long[] value){
		if(name!=null&&value!=null){
			this.termsQueryBuilder = QueryBuilders.termsQuery(name
				, Arrays.stream(value).collect(Collectors.toList()));
		}
	}

	public TermsQueryMustNot(String name, String[] value){
		if(name!=null&&value!=null){
			this.termsQueryBuilder = QueryBuilders.termsQuery(name
				, Arrays.stream(value).collect(Collectors.toList()));
		}
	}

	@Override
	public AbstractQueryBuilder<TermsQueryBuilder> abstractQueryBuilder() {
		return  termsQueryBuilder;
	}

}
